/* Esercizio 2
* Scrivere un programma che legga da tastiera una sequenza di n interi dis-
* tinti e li inserisca in un albero binario di ricerca (senza ribilanciamento). Il
* programma deve visitare opportunamente l’albero e restituire la sua altezza.
* L’input è formattato nel seguente modo: nella prima riga si trova la lunghezza
* della sequenza e nelle successive si trovano gli interi che compongono la se-
* quenza.
*/


#include <stdio.h>
#include <stdlib.h>

struct Nodo{

int key;
struct Nodo* left;
struct Nodo* right;

};

typedef struct Nodo* Tree;

void insert(Tree *t, int k){

 // crea il nodo foglia da inserire contenente la chiave
 struct Nodo* e = malloc(sizeof(struct Nodo));
 e->key = k;
 e->left = e->right = NULL;  

 struct Nodo* p;
 struct Nodo* x =  *t;

 // se l'albero è vuoto imposta e come radice dell'albero
 if (x == NULL) {
   *t = e;
   return;
 }

 // altrimenti cerca la posizione della foglia nell'albero 
 while (x != NULL){ 

   p = x;
   if (x->key < k) x = x->right;
   else x = x->left;
 }

 // ora p punta al padre del nuovo elemento da inserire in t
 // quindi si procede a linkare p ed e
 
 if (p->key < k) p->right = e;
 else p->left = e;

}


// calcolo della profondità dell'albero in maniera ricorsiva
int ComputeDepth(Tree t){

int ld, rd;
if (t == NULL) return 0;

ld = ComputeDepth(t->left);
rd = ComputeDepth(t->right); 
if (ld > rd) return 1+ld;
else return 1+rd;

}


int main() {

int numchiavi;
int k,i;
Tree t= NULL;

// inserisce tutte le chiavi in t
scanf("%d", &numchiavi);
for(i=0; i < numchiavi; i++){
    scanf("%d",&k);
    insert(&t, k);
 }

printf("%d",ComputeDepth(t));

return 0;
}

